#include <iostream>
using namespace std;

// base class
class Shape {
   friend ostream& operator<<(ostream &, const Shape &);
public:
    Shape(float x=0, float y=0) {xpos=x; ypos=y;}
    Shape(const Shape &s): xpos(s.xpos), ypos(s.ypos){}
    void display() const {cout << "xpos: " << xpos << " ypos: " <<ypos; }
    float get_xpos() const {return ypos;}
    float get_ypos() const {return xpos;}
    void move(float x_trans, float y_trans)
       {xpos +=x_trans; ypos += y_trans;}  // translate by given distance
protected:
    float xpos;  // x coordinate of the center of the shape
    float ypos;  // y coordinate of the center of the shape
};

class Square : public Shape {
   friend ostream& operator<<(ostream &, const Square&);
public:
   Square( float x=0, float y=0,float s=0): Shape(x, y), side(s){}
   Square(const Square &right):Shape(right.xpos,right.ypos), side(right.side){}
   void set_side(float s) {if (s >= 0) side = s; else side=0;}
   float get_side() const {return side;}
   float area() const {return side*side;}
   float perimeter() const {return 4*side;}
   void display() {Shape::display(); cout << ", side: " << side;}
private:
   float side;   // length of the side of the square
}; 

ostream& operator<<(ostream &out, const Shape &s)
{
    out << "xpos: " << s.xpos << " ypos: " <<s.ypos; 
}

ostream& operator<<(ostream &out, const Square&sq)
{
   out << static_cast <Shape>(sq);
   out << ", side: " << sq.side;
}
